## basis-universal 1.60

=== debian/changelog ===
basis-universal (1.60-1) unstable; urgency=low

  * Initial release.

 -- Caoimhe Chaos <caoimhechaos@protonmail.com>  Sat, 15 Mar 2025 22:26:17 +0100
