=== debian/control ===
Source: basis-universal
Section: libs
Priority: optional
Maintainer: Caoimhe Chaos <caoimhechaos@protonmail.com>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 emscripten,
 ocl-icd-libopencl1,
 ocl-icd-opencl-dev
Standards-Version: 4.7.2
Homepage: https://github.com/BinomialLLC/basis_universal
Vcs-Browser: https://github.com/BinomialLLC/basis_universal
Vcs-Git: https://github.com/BinomialLLC/basis_universal.git

Package: libbasis-universal-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ocl-icd-opencl-dev,
 ${misc:Depends},
Description:  Basis Universal GPU Texture Codec (headers and static library).
 Basis Universal is an open source supercompressed LDR/HDR GPU compressed
 texture interchange system from Binomial LLC that supports two intermediate
 file formats: the .KTX2 open standard from the Khronos Group, and our own
 ".basis" file format. These file formats support rapid transcoding to
 virtually any compressed GPU texture format released in the past ~25 years.
 .
 Our overall goal with this project is to simplify the encoding and efficient
 distribution of portable LDR and HDR GPU texture, image, and short texture
 video content in a way that is compatible with any GPU or rendering/graphics
 API.
 .
 The system supports five modes: ETC1S, UASTC LDR 4x4, UASTC HDR 4x4,
 UASTC HDR 6x6 (with or without RDO), or UASTC HDR 6x6 Intermediate
 ("GPU Photo"). The C/C++ encoder and transcoder libaries can be compiled to
 native code or WebAssembly, and all encoder/transcoder features can be
 accessed from Javascript via a C++ wrapper library which optionally
 supports WASM multithreading for fast encoding in the browser.

Package: libbasis-universal-bin
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
Description:  Basis Universal GPU Texture Codec (tools).
 Basis Universal is an open source supercompressed LDR/HDR GPU compressed
 texture interchange system from Binomial LLC that supports two intermediate
 file formats: the .KTX2 open standard from the Khronos Group, and our own
 ".basis" file format. These file formats support rapid transcoding to
 virtually any compressed GPU texture format released in the past ~25 years.
 .
 Our overall goal with this project is to simplify the encoding and efficient
 distribution of portable LDR and HDR GPU texture, image, and short texture
 video content in a way that is compatible with any GPU or rendering/graphics
 API.
 .
 The system supports five modes: ETC1S, UASTC LDR 4x4, UASTC HDR 4x4,
 UASTC HDR 6x6 (with or without RDO), or UASTC HDR 6x6 Intermediate
 ("GPU Photo"). The C/C++ encoder and transcoder libaries can be compiled to
 native code or WebAssembly, and all encoder/transcoder features can be
 accessed from Javascript via a C++ wrapper library which optionally
 supports WASM multithreading for fast encoding in the browser.

Package: libbasis-universal-doc
Architecture: all
Description: Basis Universal GPU Texture Codec library (Documentation).
 Basis Universal is an open source supercompressed LDR/HDR GPU compressed
 texture interchange system from Binomial LLC that supports two intermediate
 file formats: the .KTX2 open standard from the Khronos Group, and our own
 ".basis" file format. These file formats support rapid transcoding to
 virtually any compressed GPU texture format released in the past ~25 years.
 .
 Our overall goal with this project is to simplify the encoding and efficient
 distribution of portable LDR and HDR GPU texture, image, and short texture
 video content in a way that is compatible with any GPU or rendering/graphics
 API.
 .
 The system supports five modes: ETC1S, UASTC LDR 4x4, UASTC HDR 4x4,
 UASTC HDR 6x6 (with or without RDO), or UASTC HDR 6x6 Intermediate
 ("GPU Photo"). The C/C++ encoder and transcoder libaries can be compiled to
 native code or WebAssembly, and all encoder/transcoder features can be
 accessed from Javascript via a C++ wrapper library which optionally
 supports WASM multithreading for fast encoding in the browser.
