## basis-universal 2.0.2

=== debian/changelog ===
basis-universal (2.0.2-3) unstable; urgency=medium

  * Depend and build-depend on sse4.1-support [amd64 i386 x32]
    Closes: #1128607

 -- Russell Coker <russell@coker.com.au>  Sun, 22 Feb 2026 11:28:28 +1100

basis-universal (2.0.2-2) unstable; urgency=medium

  * Only use SSE on amd64, i386, and x32 Closes: #1128062

 -- Russell Coker <russell@coker.com.au>  Tue, 17 Feb 2026 21:15:16 +1100

basis-universal (2.0.2-1) unstable; urgency=medium

  * 2.0.2 upstream release
  * Fixed the debian/copyright file

 -- Russell Coker <russell@coker.com.au>  Sun, 15 Feb 2026 14:14:29 +1100

basis-universal (1.60-2) unstable; urgency=medium

  * Fixed the section

 -- Russell Coker <russell@coker.com.au>  Tue, 14 Oct 2025 23:50:23 +1100

basis-universal (1.60-1) unstable; urgency=medium

  * Initial release. (Closes: #1038205)

 -- Russell Coker <russell@coker.com.au>  Thu, 25 Sep 2025 16:27:17 +1000
