=== debian/control ===
Source: basis-universal
Section: devel
Priority: optional
Maintainer: Russell Coker <russell@coker.com.au>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 sse4.1-support [amd64 i386 x32]
Standards-Version: 4.7.2
Homepage: https://github.com/BinomialLLC/basis_universal
#Vcs-Browser: https://salsa.debian.org/debian/basis-universal
#Vcs-Git: https://salsa.debian.org/debian/basis-universal.git

Package: gpu-basis-universal
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 sse4.1-support [amd64 i386 x32]
Description: GPU compressed texture encoding system
 Basis Universal is an open source supercompressed LDR/HDR GPU compressed
 texture interchange system from Binomial LLC that supports two intermediate
 file formats: the .KTX2 open standard from the Khronos Group, and the
 ".basis" file format. These file formats support rapid transcoding to
 virtually any compressed GPU texture format released in the past ~25 years.
 .
 Used for compiling data files for games.
