=== debian/rules ===
--- 
+++ 
@@ -14,14 +14,29 @@
 # Package maintainers to append LDFLAGS.
 #export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
+DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
+ifeq ($(DEB_BUILD_ARCH),amd64)
+    SSE=-DBASISU_SSE=1
+endif
+ifeq ($(DEB_BUILD_ARCH),i386)
+    SSE=-DBASISU_SSE=1
+endif
+ifeq ($(DEB_BUILD_ARCH),x32)
+    SSE=-DBASISU_SSE=1
+endif
 
 %:
-	dh $@ --buildsystem=cmake
+	dh $@
 
+override_dh_auto_clean:
+	dh_auto_clean
+	rm -f bin/*
+
+override_dh_auto_configure:
+	dh_auto_configure -- $(SSE)
 
 # dh_make generated override targets.
 # This is an example for Cmake (see <https://bugs.debian.org/641051>).
-override_dh_auto_configure:
-	dh_auto_configure -- \
-	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
-	-DOPENCL=ON
+#override_dh_auto_configure:
+#	dh_auto_configure -- \
+#	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)
